type mode;
type t;

t of_string(string);
t of_stream(Stdio::FILE);

*(int, int) get_location(t);

union token {
    string Id;
    string Operator;
    string Blank;
}

mode make_mode();
void set_is_id(mode, *(bool (char)));
void set_is_op(mode, *(bool (char)));
void set_is_blank(mode, *(bool (char)));
void add_operator(mode, string);

char get_char(t);
token get_token(t, mode);

// vim:sts=4:sw=4
