/*
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 831 $ $LastChangedDate: 2002-09-01 12:27:33 +0200 (Sun, 01 Sep 2002) $
 *
 * Parser - Bison parser for Gont.
 */

#define YYSTYPE void*

typedef struct yyltype
{
  int first_line;
  int first_column;

  int last_line;
  int last_column;
} yyltype;

#define YYLTYPE yyltype
#define YYLTYPE_IS_TRIVIAL 1

#include "parser.tab.h"

int yylex(void);
