type <'a, 'b>t;

union <'a, 'b>token {
    string String;
    char Char;
    string Int;
    string Float;
    string Id;
    string Comment;
    string Blank;
    string Junk;
    'a Keyword;
    'b Operator;
}

<'a, 'b>t of_genlex(Genlex::t);

*(int, int) beg_location(<'a, 'b>t);
*(int, int) end_location(<'a, 'b>t);
<'a, 'b>token get_token(<'a, 'b>t);

void add_keyword(<'a, 'b>t, string, 'a);
void add_operator(<'a, 'b>t, string, 'b);

void keep_comments(<'a, 'b>t);
void keep_blanks(<'a, 'b>t);

// vim:sts=4:sw=4
